//
// Media.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct Media: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var mediaKey: String?
    public var preferredPhotoYN: Bool?
    public var deleted: Bool?
    public var changedByMemberKeyNumeric: Int?
    public var imageHeight: Int?
    public var imageWidth: Int?
    public var mediaKeyNumeric: Int?
    public var order: Int?
    public var resourceRecordKeyNumeric: Int?
    public var hash: String?
    public var changedByMemberID: String?
    public var changedByMemberKey: String?
    public var longDescription: String?
    public var mediaHTML: String?
    public var mediaObjectID: String?
    public var mediaURL: String?
    public var originatingSystemID: String?
    public var originatingSystemMediaKey: String?
    public var originatingSystemName: String?
    public var resourceRecordID: String?
    public var resourceRecordKey: String?
    public var shortDescription: String?
    public var sourceSystemID: String?
    public var sourceSystemMediaKey: String?
    public var sourceSystemName: String?
    public var permission: [String]?
    public var className: String?
    public var imageOf: String?
    public var imageSizeDescription: String?
    public var mediaCategory: String?
    public var mediaStatus: String?
    public var mediaType: String?
    public var resourceName: String?
    public var modificationTimestamp: Date?
    public var mediaModificationTimestamp: Date?
    public var updatedAt: Date?
    public var createdAt: Date?
    public var labels: [Label]?
    public var segmaps: [Segmap]?
    public var trials: [Trial]?

    public init(id: Int? = nil, mediaKey: String? = nil, preferredPhotoYN: Bool? = nil, deleted: Bool? = nil, changedByMemberKeyNumeric: Int? = nil, imageHeight: Int? = nil, imageWidth: Int? = nil, mediaKeyNumeric: Int? = nil, order: Int? = nil, resourceRecordKeyNumeric: Int? = nil, hash: String? = nil, changedByMemberID: String? = nil, changedByMemberKey: String? = nil, longDescription: String? = nil, mediaHTML: String? = nil, mediaObjectID: String? = nil, mediaURL: String? = nil, originatingSystemID: String? = nil, originatingSystemMediaKey: String? = nil, originatingSystemName: String? = nil, resourceRecordID: String? = nil, resourceRecordKey: String? = nil, shortDescription: String? = nil, sourceSystemID: String? = nil, sourceSystemMediaKey: String? = nil, sourceSystemName: String? = nil, permission: [String]? = nil, className: String? = nil, imageOf: String? = nil, imageSizeDescription: String? = nil, mediaCategory: String? = nil, mediaStatus: String? = nil, mediaType: String? = nil, resourceName: String? = nil, modificationTimestamp: Date? = nil, mediaModificationTimestamp: Date? = nil, updatedAt: Date? = nil, createdAt: Date? = nil, labels: [Label]? = nil, segmaps: [Segmap]? = nil, trials: [Trial]? = nil) {
        self.id = id
        self.mediaKey = mediaKey
        self.preferredPhotoYN = preferredPhotoYN
        self.deleted = deleted
        self.changedByMemberKeyNumeric = changedByMemberKeyNumeric
        self.imageHeight = imageHeight
        self.imageWidth = imageWidth
        self.mediaKeyNumeric = mediaKeyNumeric
        self.order = order
        self.resourceRecordKeyNumeric = resourceRecordKeyNumeric
        self.hash = hash
        self.changedByMemberID = changedByMemberID
        self.changedByMemberKey = changedByMemberKey
        self.longDescription = longDescription
        self.mediaHTML = mediaHTML
        self.mediaObjectID = mediaObjectID
        self.mediaURL = mediaURL
        self.originatingSystemID = originatingSystemID
        self.originatingSystemMediaKey = originatingSystemMediaKey
        self.originatingSystemName = originatingSystemName
        self.resourceRecordID = resourceRecordID
        self.resourceRecordKey = resourceRecordKey
        self.shortDescription = shortDescription
        self.sourceSystemID = sourceSystemID
        self.sourceSystemMediaKey = sourceSystemMediaKey
        self.sourceSystemName = sourceSystemName
        self.permission = permission
        self.className = className
        self.imageOf = imageOf
        self.imageSizeDescription = imageSizeDescription
        self.mediaCategory = mediaCategory
        self.mediaStatus = mediaStatus
        self.mediaType = mediaType
        self.resourceName = resourceName
        self.modificationTimestamp = modificationTimestamp
        self.mediaModificationTimestamp = mediaModificationTimestamp
        self.updatedAt = updatedAt
        self.createdAt = createdAt
        self.labels = labels
        self.segmaps = segmaps
        self.trials = trials
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case mediaKey = "MediaKey"
        case preferredPhotoYN = "PreferredPhotoYN"
        case deleted = "Deleted"
        case changedByMemberKeyNumeric = "ChangedByMemberKeyNumeric"
        case imageHeight = "ImageHeight"
        case imageWidth = "ImageWidth"
        case mediaKeyNumeric = "MediaKeyNumeric"
        case order = "Order"
        case resourceRecordKeyNumeric = "ResourceRecordKeyNumeric"
        case hash = "Hash"
        case changedByMemberID = "ChangedByMemberID"
        case changedByMemberKey = "ChangedByMemberKey"
        case longDescription = "LongDescription"
        case mediaHTML = "MediaHTML"
        case mediaObjectID = "MediaObjectID"
        case mediaURL = "MediaURL"
        case originatingSystemID = "OriginatingSystemID"
        case originatingSystemMediaKey = "OriginatingSystemMediaKey"
        case originatingSystemName = "OriginatingSystemName"
        case resourceRecordID = "ResourceRecordID"
        case resourceRecordKey = "ResourceRecordKey"
        case shortDescription = "ShortDescription"
        case sourceSystemID = "SourceSystemID"
        case sourceSystemMediaKey = "SourceSystemMediaKey"
        case sourceSystemName = "SourceSystemName"
        case permission = "Permission"
        case className = "ClassName"
        case imageOf = "ImageOf"
        case imageSizeDescription = "ImageSizeDescription"
        case mediaCategory = "MediaCategory"
        case mediaStatus = "MediaStatus"
        case mediaType = "MediaType"
        case resourceName = "ResourceName"
        case modificationTimestamp = "ModificationTimestamp"
        case mediaModificationTimestamp = "MediaModificationTimestamp"
        case updatedAt
        case createdAt
        case labels = "Labels"
        case segmaps = "Segmaps"
        case trials = "Trials"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(mediaKey, forKey: .mediaKey)
        try container.encodeIfPresent(preferredPhotoYN, forKey: .preferredPhotoYN)
        try container.encodeIfPresent(deleted, forKey: .deleted)
        try container.encodeIfPresent(changedByMemberKeyNumeric, forKey: .changedByMemberKeyNumeric)
        try container.encodeIfPresent(imageHeight, forKey: .imageHeight)
        try container.encodeIfPresent(imageWidth, forKey: .imageWidth)
        try container.encodeIfPresent(mediaKeyNumeric, forKey: .mediaKeyNumeric)
        try container.encodeIfPresent(order, forKey: .order)
        try container.encodeIfPresent(resourceRecordKeyNumeric, forKey: .resourceRecordKeyNumeric)
        try container.encodeIfPresent(hash, forKey: .hash)
        try container.encodeIfPresent(changedByMemberID, forKey: .changedByMemberID)
        try container.encodeIfPresent(changedByMemberKey, forKey: .changedByMemberKey)
        try container.encodeIfPresent(longDescription, forKey: .longDescription)
        try container.encodeIfPresent(mediaHTML, forKey: .mediaHTML)
        try container.encodeIfPresent(mediaObjectID, forKey: .mediaObjectID)
        try container.encodeIfPresent(mediaURL, forKey: .mediaURL)
        try container.encodeIfPresent(originatingSystemID, forKey: .originatingSystemID)
        try container.encodeIfPresent(originatingSystemMediaKey, forKey: .originatingSystemMediaKey)
        try container.encodeIfPresent(originatingSystemName, forKey: .originatingSystemName)
        try container.encodeIfPresent(resourceRecordID, forKey: .resourceRecordID)
        try container.encodeIfPresent(resourceRecordKey, forKey: .resourceRecordKey)
        try container.encodeIfPresent(shortDescription, forKey: .shortDescription)
        try container.encodeIfPresent(sourceSystemID, forKey: .sourceSystemID)
        try container.encodeIfPresent(sourceSystemMediaKey, forKey: .sourceSystemMediaKey)
        try container.encodeIfPresent(sourceSystemName, forKey: .sourceSystemName)
        try container.encodeIfPresent(permission, forKey: .permission)
        try container.encodeIfPresent(className, forKey: .className)
        try container.encodeIfPresent(imageOf, forKey: .imageOf)
        try container.encodeIfPresent(imageSizeDescription, forKey: .imageSizeDescription)
        try container.encodeIfPresent(mediaCategory, forKey: .mediaCategory)
        try container.encodeIfPresent(mediaStatus, forKey: .mediaStatus)
        try container.encodeIfPresent(mediaType, forKey: .mediaType)
        try container.encodeIfPresent(resourceName, forKey: .resourceName)
        try container.encodeIfPresent(modificationTimestamp, forKey: .modificationTimestamp)
        try container.encodeIfPresent(mediaModificationTimestamp, forKey: .mediaModificationTimestamp)
        try container.encodeIfPresent(updatedAt, forKey: .updatedAt)
        try container.encodeIfPresent(createdAt, forKey: .createdAt)
        try container.encodeIfPresent(labels, forKey: .labels)
        try container.encodeIfPresent(segmaps, forKey: .segmaps)
        try container.encodeIfPresent(trials, forKey: .trials)
    }
}

